<template lang="pug">

mixin Param
  BaseParamInput.col-12.col-sm-6.col-lg-4.col-xl-2&attributes(attributes)

mixin ParamReadonly
  BaseParamReadonly.col-12.col-sm-6.col-lg-4.col-xl-2&attributes(attributes)

.row.no-gutters(:id='channelId')
  .col-12
    BaseCollapsible(:class="{ 'text-muted': !currentEnabled }" :expand='showAcq || showZsp')
      template(v-slot:header)
        .row
          .col-6.col-md-3
            .row.no-gutters
              BaseToggle.col-auto(ref='enabled' :value='enabled' :inEdit='inEdit'
                  @click.native.stop @edit='pushEditValue("enabled", $event)')
              .col-auto #[strong CHANNEL{{channel}}]
          .col-6(v-if="isLoading || isSending") #[i.fa.fa-spinner.fa-pulse]
          .col-6(v-else) {{detectorType}}

      template(v-slot:default='c')
        BaseAnimationBlock(anim="delay" :appear='false' mode='' :options='{ outDelay: 0.3 }')
          .col-12(v-if='c.isExpanded')
            BaseCollapsible.x-acq(:expand='showAcq')
              template(v-slot:header)
                strong Acquisition
              .col-12
                .row.b-param-container
                  +Param(ref="detectorType" title="Detector Name"
                         :value="detectorType" :inEdit="inEdit" maxlength="4"
                         @edit='pushEditValue("detectorType", $event)')
                  +Param(ref="detectorId" title="Detector ID" type='number'
                         @wheel.native='$event.target.blur()'
                         :value="detectorId" :inEdit="inEdit"
                         @edit='pushEditValue("detectorId", $event)')
                  BaseParamList.col-12.col-sm-6.col-lg-4.col-xl-2(ref="fullScale" title="Full Scale [mV]"
                      :value="fullScale" :inEdit="inEdit"
                      @edit='updateEditOffset(); pushEditValue("fullScale", $event)')
                    template(#options='')
                      option(v-for='value in FullScaleValues') {{ value }}
                  +ParamReadonly(ref="offset" title="Offset [mV]"
                                 :value="offset" type="number"
                                 :max="OffsetLimits" :min="-OffsetLimits" :inEdit="inEdit"
                                 @wheel.native='$event.target.blur()'
                                 @edit='checkOffsetWarning(); pushEditValue("offset", $event)')
                  +Param(ref="lowerLimit" title="Lower Limit [mV]" type="number"
                    :value="lowerLimit" :inEdit="inEdit"
                    @edit="updateEditOffset()")
                  BaseParamList.col-12.col-sm-6.col-lg-4.col-xl-2(ref="impedance" title="Impedance [Ω]"
                    :value="impedance" :inEdit="inEdit"
                    :options="ImpedanceValues"
                    @edit='pushEditValue("impedance", $event)')

            BaseCollapsible.x-zsp(:expand='showZsp')
              template(v-slot:header)
                .row.no-gutters
                  BaseToggle.col-auto(ref='isZSP' :value='isZSP' :inEdit='inEdit'
                      @click.stop.native @edit='onZSPEdit')
                  .col-auto #[strong Zero Suppression]
              .col-12
                .row.b-param-container(v-show='!inEdit || isZSPEdit')
                  BaseParamList.col-12.col-sm-6.col-lg-4.col-xl-2(ref="thresholdSign"
                    :value="thresholdSign" :inEdit="inEdit"
                    :options='[ { value: 1, text: "+" }, { value: 0, text: "-" } ]'
                    title="Signal Leading Edge"
                    @edit='pushEditValue("thresholdSign", $event)')
                  +Param(ref="threshold" title="Threshold [mV]"
                         :value="threshold" :inEdit="inEdit" type='number' step='any'
                         @edit='pushEditValue("threshold", $event)')
                  +Param(ref="zsStart" title="∅ Delay [ns]"
                         :value="zsStart" :inEdit="inEdit"
                         @edit='pushEditValue("zsStart", $event)')
                  +Param(ref="preSamples" title="Pre Samples [S]"
                         :value="preSamples" :inEdit="inEdit"
                         @edit='pushEditValue("preSamples", $event)')
                  +Param(ref="postSamples" title="Post Samples [S]"
                         :value="postSamples" :inEdit="inEdit"
                         @edit='pushEditValue("postSamples", $event)')
                .row.b-param-container(v-if='inEdit && !isZSPEdit')
                  +ParamReadonly(title="Signal Leading Edge"
                      :value="edit.thresholdSign ? '+' : '-'" :inEdit="inEdit")
                  +ParamReadonly(title="Threshold [mV]"
                      :value="edit.threshold" :inEdit="inEdit")
                  +ParamReadonly(title="∅ Delay [ns]"
                      :value="edit.zsStart" :inEdit="inEdit")
                  +ParamReadonly(title="Pre Samples [S]"
                      :value="edit.preSamples" :inEdit="inEdit")
                  +ParamReadonly(title="Post Samples [S]"
                      :value="edit.postSamples" :inEdit="inEdit")
</template>
<script>

export { default } from './Channel.vue.js';

</script>
